summaryrefslogtreecommitdiff
path: root/src/share/common
blob: f954bb94a071d6d78891878d526be950bbe488b1 (plain)
  1. # -*-shell-script-*-
  2. # This should be sourced by bash (though we welcome changes to make it POSIX sh compliant)
  3. # Shared sh functions for the monkeysphere
  4. #
  5. # Written by
  6. # Jameson Rollins <jrollins@finestructure.net>
  7. # Jamie McClelland <jm@mayfirst.org>
  8. # Daniel Kahn Gillmor <dkg@fifthhorseman.net>
  9. #
  10. # Copyright 2008-2009, released under the GPL, version 3 or later
  11. # all-caps variables are meant to be user supplied (ie. from config
  12. # file) and are considered global
  13. ########################################################################
  14. ### UTILITY FUNCTIONS
  15. # output version info
  16. version() {
  17. cat "${SYSSHAREDIR}/VERSION"
  18. }
  19. # failure function. exits with code 255, unless specified otherwise.
  20. failure() {
  21. [ "$1" ] && echo "$1" >&2
  22. exit ${2:-'255'}
  23. }
  24. # write output to stderr based on specified LOG_LEVEL the first
  25. # parameter is the priority of the output, and everything else is what
  26. # is echoed to stderr. If there is nothing else, then output comes
  27. # from stdin, and is not prefaced by log prefix.
  28. log() {
  29. local priority
  30. local level
  31. local output
  32. local alllevels
  33. local found=
  34. # don't include SILENT in alllevels: it's handled separately
  35. # list in decreasing verbosity (all caps).
  36. # separate with $IFS explicitly, since we do some fancy footwork
  37. # elsewhere.
  38. alllevels="DEBUG${IFS}VERBOSE${IFS}INFO${IFS}ERROR"
  39. # translate lowers to uppers in global log level
  40. LOG_LEVEL=$(echo "$LOG_LEVEL" | tr "[:lower:]" "[:upper:]")
  41. # just go ahead and return if the log level is silent
  42. if [ "$LOG_LEVEL" = 'SILENT' ] ; then
  43. return
  44. fi
  45. for level in $alllevels ; do
  46. if [ "$LOG_LEVEL" = "$level" ] ; then
  47. found=true
  48. fi
  49. done
  50. if [ -z "$found" ] ; then
  51. # default to INFO:
  52. LOG_LEVEL=INFO
  53. fi
  54. # get priority from first parameter, translating all lower to
  55. # uppers
  56. priority=$(echo "$1" | tr "[:lower:]" "[:upper:]")
  57. shift
  58. # scan over available levels
  59. for level in $alllevels ; do
  60. # output if the log level matches, set output to true
  61. # this will output for all subsequent loops as well.
  62. if [ "$LOG_LEVEL" = "$level" ] ; then
  63. output=true
  64. fi
  65. if [ "$priority" = "$level" -a "$output" = 'true' ] ; then
  66. if [ "$1" ] ; then
  67. echo "$@"
  68. else
  69. cat
  70. fi | sed 's/^/'"${LOG_PREFIX}"'/' >&2
  71. fi
  72. done
  73. }
  74. # run command as monkeysphere user
  75. su_monkeysphere_user() {
  76. # our main goal here is to run the given command as the the
  77. # monkeysphere user, but without prompting for any sort of
  78. # authentication. If this is not possible, we should just fail.
  79. # FIXME: our current implementation is overly restrictive, because
  80. # there may be some su PAM configurations that would allow su
  81. # "$MONKEYSPHERE_USER" -c "$@" to Just Work without prompting,
  82. # allowing specific users to invoke commands which make use of
  83. # this user.
  84. # chpst (from runit) would be nice to use, but we don't want to
  85. # introduce an extra dependency just for this. This may be a
  86. # candidate for re-factoring if we switch implementation languages.
  87. case $(id -un) in
  88. # if monkeysphere user, run the command under bash
  89. "$MONKEYSPHERE_USER")
  90. bash -c "$@"
  91. ;;
  92. # if root, su command as monkeysphere user
  93. 'root')
  94. su "$MONKEYSPHERE_USER" -c "$@"
  95. ;;
  96. # otherwise, fail
  97. *)
  98. log error "non-privileged user."
  99. ;;
  100. esac
  101. }
  102. # cut out all comments(#) and blank lines from standard input
  103. meat() {
  104. grep -v -e "^[[:space:]]*#" -e '^$' "$1"
  105. }
  106. # cut a specified line from standard input
  107. cutline() {
  108. head --line="$1" "$2" | tail -1
  109. }
  110. # make a temporary directory
  111. msmktempdir() {
  112. mktemp -d ${TMPDIR:-/tmp}/monkeysphere.XXXXXXXXXX
  113. }
  114. # make a temporary file
  115. msmktempfile() {
  116. mktemp ${TMPDIR:-/tmp}/monkeysphere.XXXXXXXXXX
  117. }
  118. # this is a wrapper for doing lock functions.
  119. #
  120. # it lets us depend on either lockfile-progs (preferred) or procmail's
  121. # lockfile, and should
  122. lock() {
  123. local use_lockfileprogs=true
  124. local action="$1"
  125. local file="$2"
  126. if ! ( type lockfile-create &>/dev/null ) ; then
  127. if ! ( type lockfile &>/dev/null ); then
  128. failure "Neither lockfile-create nor lockfile are in the path!"
  129. fi
  130. use_lockfileprogs=
  131. fi
  132. case "$action" in
  133. create)
  134. if [ -n "$use_lockfileprogs" ] ; then
  135. lockfile-create "$file" || failure "unable to lock '$file'"
  136. else
  137. lockfile -r 20 "${file}.lock" || failure "unable to lock '$file'"
  138. fi
  139. log debug "lock created on '$file'."
  140. ;;
  141. touch)
  142. if [ -n "$use_lockfileprogs" ] ; then
  143. lockfile-touch --oneshot "$file"
  144. else
  145. : Nothing to do here
  146. fi
  147. log debug "lock touched on '$file'."
  148. ;;
  149. remove)
  150. if [ -n "$use_lockfileprogs" ] ; then
  151. lockfile-remove "$file"
  152. else
  153. rm -f "${file}.lock"
  154. fi
  155. log debug "lock removed on '$file'."
  156. ;;
  157. *)
  158. failure "bad argument for lock subfunction '$action'"
  159. esac
  160. }
  161. # for portability, between gnu date and BSD date.
  162. # arguments should be: number longunits format
  163. # e.g. advance_date 20 seconds +%F
  164. advance_date() {
  165. local gnutry
  166. local number="$1"
  167. local longunits="$2"
  168. local format="$3"
  169. local shortunits
  170. # try things the GNU way first
  171. if date -d "$number $longunits" "$format" &>/dev/null; then
  172. date -d "$number $longunits" "$format"
  173. else
  174. # otherwise, convert to (a limited version of) BSD date syntax:
  175. case "$longunits" in
  176. years)
  177. shortunits=y
  178. ;;
  179. months)
  180. shortunits=m
  181. ;;
  182. weeks)
  183. shortunits=w
  184. ;;
  185. days)
  186. shortunits=d
  187. ;;
  188. hours)
  189. shortunits=H
  190. ;;
  191. minutes)
  192. shortunits=M
  193. ;;
  194. seconds)
  195. shortunits=S
  196. ;;
  197. *)
  198. # this is a longshot, and will likely fail; oh well.
  199. shortunits="$longunits"
  200. esac
  201. date "-v+${number}${shortunits}" "$format"
  202. fi
  203. }
  204. # check that characters are in a string (in an AND fashion).
  205. # used for checking key capability
  206. # check_capability capability a [b...]
  207. check_capability() {
  208. local usage
  209. local capcheck
  210. usage="$1"
  211. shift 1
  212. for capcheck ; do
  213. if echo "$usage" | grep -q -v "$capcheck" ; then
  214. return 1
  215. fi
  216. done
  217. return 0
  218. }
  219. # hash of a file
  220. file_hash() {
  221. if type md5sum &>/dev/null ; then
  222. md5sum "$1"
  223. elif type md5 &>/dev/null ; then
  224. md5 "$1"
  225. else
  226. failure "Neither md5sum nor md5 are in the path!"
  227. fi
  228. }
  229. # convert escaped characters in pipeline from gpg output back into
  230. # original character
  231. # FIXME: undo all escape character translation in with-colons gpg
  232. # output
  233. gpg_unescape() {
  234. sed 's/\\x3a/:/g'
  235. }
  236. # convert nasty chars into gpg-friendly form in pipeline
  237. # FIXME: escape everything, not just colons!
  238. gpg_escape() {
  239. sed 's/:/\\x3a/g'
  240. }
  241. # prompt for GPG-formatted expiration, and emit result on stdout
  242. get_gpg_expiration() {
  243. local keyExpire
  244. keyExpire="$1"
  245. if [ -z "$keyExpire" -a "$PROMPT" = 'true' ]; then
  246. cat >&2 <<EOF
  247. Please specify how long the key should be valid.
  248. 0 = key does not expire
  249. <n> = key expires in n days
  250. <n>w = key expires in n weeks
  251. <n>m = key expires in n months
  252. <n>y = key expires in n years
  253. EOF
  254. while [ -z "$keyExpire" ] ; do
  255. read -p "Key is valid for? (0) " keyExpire
  256. if ! test_gpg_expire ${keyExpire:=0} ; then
  257. echo "invalid value" >&2
  258. unset keyExpire
  259. fi
  260. done
  261. elif ! test_gpg_expire "$keyExpire" ; then
  262. failure "invalid key expiration value '$keyExpire'."
  263. fi
  264. echo "$keyExpire"
  265. }
  266. passphrase_prompt() {
  267. local prompt="$1"
  268. local fifo="$2"
  269. local PASS
  270. if [ "$DISPLAY" ] && type "${SSH_ASKPASS:-ssh-askpass}" >/dev/null; then
  271. printf 'Launching "%s"\n' "${SSH_ASKPASS:-ssh-askpass}" | log info
  272. printf '(with prompt "%s")\n' "$prompt" | log debug
  273. "${SSH_ASKPASS:-ssh-askpass}" "$prompt" > "$fifo"
  274. else
  275. read -s -p "$prompt" PASS
  276. # Uses the builtin echo, so should not put the passphrase into
  277. # the process table. I think. --dkg
  278. echo "$PASS" > "$fifo"
  279. fi
  280. }
  281. # remove all lines with specified string from specified file
  282. remove_line() {
  283. local file
  284. local string
  285. local tempfile
  286. file="$1"
  287. string="$2"
  288. if [ -z "$file" -o -z "$string" ] ; then
  289. return 1
  290. fi
  291. if [ ! -e "$file" ] ; then
  292. return 1
  293. fi
  294. # if the string is in the file...
  295. if grep -q -F "$string" "$file" 2>/dev/null ; then
  296. tempfile=$(mktemp "${file}.XXXXXXX") || \
  297. failure "Unable to make temp file '${file}.XXXXXXX'"
  298. # remove the line with the string, and return 0
  299. grep -v -F "$string" "$file" >"$tempfile"
  300. cat "$tempfile" > "$file"
  301. rm "$tempfile"
  302. return 0
  303. # otherwise return 1
  304. else
  305. return 1
  306. fi
  307. }
  308. # remove all lines with MonkeySphere strings in file
  309. remove_monkeysphere_lines() {
  310. local file
  311. local tempfile
  312. file="$1"
  313. # return error if file does not exist
  314. if [ ! -e "$file" ] ; then
  315. return 1
  316. fi
  317. # just return ok if the file is empty, since there aren't any
  318. # lines to remove
  319. if [ ! -s "$file" ] ; then
  320. return 0
  321. fi
  322. tempfile=$(mktemp "${file}.XXXXXXX") || \
  323. failure "Could not make temporary file '${file}.XXXXXXX'."
  324. egrep -v '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$' \
  325. "$file" >"$tempfile"
  326. cat "$tempfile" > "$file"
  327. rm "$tempfile"
  328. }
  329. # translate ssh-style path variables %h and %u
  330. translate_ssh_variables() {
  331. local uname
  332. local home
  333. uname="$1"
  334. path="$2"
  335. # get the user's home directory
  336. userHome=$(get_homedir "$uname")
  337. # translate '%u' to user name
  338. path=${path/\%u/"$uname"}
  339. # translate '%h' to user home directory
  340. path=${path/\%h/"$userHome"}
  341. echo "$path"
  342. }
  343. # test that a string to conforms to GPG's expiration format
  344. test_gpg_expire() {
  345. echo "$1" | egrep -q "^[0-9]+[mwy]?$"
  346. }
  347. # check that a file is properly owned, and that all it's parent
  348. # directories are not group/other writable
  349. check_key_file_permissions() {
  350. local uname
  351. local path
  352. local stat
  353. local access
  354. local gAccess
  355. local oAccess
  356. # function to check that the given permission corresponds to writability
  357. is_write() {
  358. [ "$1" = "w" ]
  359. }
  360. uname="$1"
  361. path="$2"
  362. log debug "checking path permission '$path'..."
  363. # return 255 if cannot stat file
  364. if ! stat=$(ls -ld "$path" 2>/dev/null) ; then
  365. log error "could not stat path '$path'."
  366. return 255
  367. fi
  368. owner=$(echo "$stat" | awk '{ print $3 }')
  369. gAccess=$(echo "$stat" | cut -c6)
  370. oAccess=$(echo "$stat" | cut -c9)
  371. # return 1 if path has invalid owner
  372. if [ "$owner" != "$uname" -a "$owner" != 'root' ] ; then
  373. log error "improper ownership on path '$path':"
  374. log error " $owner != ($uname|root)"
  375. return 1
  376. fi
  377. # return 2 if path has group or other writability
  378. if is_write "$gAccess" || is_write "$oAccess" ; then
  379. log error "improper group or other writability on path '$path':"
  380. log error " group: $gAccess, other: $oAccess"
  381. return 2
  382. fi
  383. # return zero if all clear, or go to next path
  384. if [ "$path" = '/' ] ; then
  385. log debug "path ok."
  386. return 0
  387. else
  388. check_key_file_permissions "$uname" $(dirname "$path")
  389. fi
  390. }
  391. # return a list of all users on the system
  392. list_users() {
  393. if type getent &>/dev/null ; then
  394. # for linux and FreeBSD systems
  395. getent passwd | cut -d: -f1
  396. elif type dscl &>/dev/null ; then
  397. # for Darwin systems
  398. dscl localhost -list /Search/Users
  399. fi
  400. }
  401. # return the path to the home directory of a user
  402. get_homedir() {
  403. local uname=${1:-`whoami`}
  404. eval "echo ~${uname}"
  405. }
  406. ### CONVERSION UTILITIES
  407. # output the ssh key for a given key ID
  408. gpg2ssh() {
  409. local keyID
  410. keyID="$1"
  411. gpg --export "$keyID" | openpgp2ssh "$keyID" 2>/dev/null
  412. }
  413. # output known_hosts line from ssh key
  414. ssh2known_hosts() {
  415. local host
  416. local port
  417. local key
  418. # FIXME this does not properly deal with IPv6 hosts using the
  419. # standard port (because it's unclear whether their final
  420. # colon-delimited address section is a port number or an address
  421. # string)
  422. host=${1%:*}
  423. port=${1##*:}
  424. key="$2"
  425. # specify the host and port properly for new ssh known_hosts
  426. # format
  427. if [ "$port" != "$host" ] ; then
  428. host="[${host}]:${port}"
  429. fi
  430. printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE"
  431. }
  432. # output authorized_keys line from ssh key
  433. ssh2authorized_keys() {
  434. local userID
  435. local key
  436. userID="$1"
  437. key="$2"
  438. printf "%s MonkeySphere%s %s\n" "$key" "$DATE" "$userID"
  439. }
  440. # convert key from gpg to ssh known_hosts format
  441. gpg2known_hosts() {
  442. local host
  443. local keyID
  444. local key
  445. host="$1"
  446. keyID="$2"
  447. key=$(gpg2ssh "$keyID")
  448. # NOTE: it seems that ssh-keygen -R removes all comment fields from
  449. # all lines in the known_hosts file. why?
  450. # NOTE: just in case, the COMMENT can be matched with the
  451. # following regexp:
  452. # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
  453. printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE"
  454. }
  455. # convert key from gpg to ssh authorized_keys format
  456. gpg2authorized_keys() {
  457. local userID
  458. local keyID
  459. local key
  460. userID="$1"
  461. keyID="$2"
  462. key=$(gpg2ssh "$keyID")
  463. # NOTE: just in case, the COMMENT can be matched with the
  464. # following regexp:
  465. # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
  466. printf "%s MonkeySphere%s %s\n" "$key" "$DATE" "$userID"
  467. }
  468. ### GPG UTILITIES
  469. # retrieve all keys with given user id from keyserver
  470. # FIXME: need to figure out how to retrieve all matching keys
  471. # (not just first N (5 in this case))
  472. gpg_fetch_userid() {
  473. local returnCode=0
  474. local userID
  475. if [ "$CHECK_KEYSERVER" != 'true' ] ; then
  476. return 0
  477. fi
  478. userID="$1"
  479. log verbose " checking keyserver $KEYSERVER... "
  480. echo 1,2,3,4,5 | \
  481. gpg --quiet --batch --with-colons \
  482. --command-fd 0 --keyserver "$KEYSERVER" \
  483. --search ="$userID" &>/dev/null
  484. returnCode="$?"
  485. return "$returnCode"
  486. }
  487. ########################################################################
  488. ### PROCESSING FUNCTIONS
  489. # userid and key policy checking
  490. # the following checks policy on the returned keys
  491. # - checks that full key has appropriate valididy (u|f)
  492. # - checks key has specified capability (REQUIRED_*_KEY_CAPABILITY)
  493. # - checks that requested user ID has appropriate validity
  494. # (see /usr/share/doc/gnupg/DETAILS.gz)
  495. # output is one line for every found key, in the following format:
  496. #
  497. # flag:sshKey
  498. #
  499. # "flag" is an acceptability flag, 0 = ok, 1 = bad
  500. # "sshKey" is the translated gpg key
  501. #
  502. # all log output must go to stderr, as stdout is used to pass the
  503. # flag:sshKey to the calling function.
  504. #
  505. # expects global variable: "MODE"
  506. process_user_id() {
  507. local returnCode=0
  508. local userID
  509. local requiredCapability
  510. local requiredPubCapability
  511. local gpgOut
  512. local type
  513. local validity
  514. local keyid
  515. local uidfpr
  516. local usage
  517. local keyOK
  518. local uidOK
  519. local lastKey
  520. local lastKeyOK
  521. local fingerprint
  522. userID="$1"
  523. # set the required key capability based on the mode
  524. if [ "$MODE" = 'known_hosts' ] ; then
  525. requiredCapability="$REQUIRED_HOST_KEY_CAPABILITY"
  526. elif [ "$MODE" = 'authorized_keys' ] ; then
  527. requiredCapability="$REQUIRED_USER_KEY_CAPABILITY"
  528. fi
  529. requiredPubCapability=$(echo "$requiredCapability" | tr "[:lower:]" "[:upper:]")
  530. # fetch the user ID if necessary/requested
  531. gpg_fetch_userid "$userID"
  532. # output gpg info for (exact) userid and store
  533. gpgOut=$(gpg --list-key --fixed-list-mode --with-colon \
  534. --with-fingerprint --with-fingerprint \
  535. ="$userID" 2>/dev/null) || returnCode="$?"
  536. # if the gpg query return code is not 0, return 1
  537. if [ "$returnCode" -ne 0 ] ; then
  538. log verbose " no primary keys found."
  539. return 1
  540. fi
  541. # loop over all lines in the gpg output and process.
  542. echo "$gpgOut" | cut -d: -f1,2,5,10,12 | \
  543. while IFS=: read -r type validity keyid uidfpr usage ; do
  544. # process based on record type
  545. case $type in
  546. 'pub') # primary keys
  547. # new key, wipe the slate
  548. keyOK=
  549. uidOK=
  550. lastKey=pub
  551. lastKeyOK=
  552. fingerprint=
  553. log verbose " primary key found: $keyid"
  554. # if overall key is not valid, skip
  555. if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
  556. log debug " - unacceptable primary key validity ($validity)."
  557. continue
  558. fi
  559. # if overall key is disabled, skip
  560. if check_capability "$usage" 'D' ; then
  561. log debug " - key disabled."
  562. continue
  563. fi
  564. # if overall key capability is not ok, skip
  565. if ! check_capability "$usage" $requiredPubCapability ; then
  566. log debug " - unacceptable primary key capability ($usage)."
  567. continue
  568. fi
  569. # mark overall key as ok
  570. keyOK=true
  571. # mark primary key as ok if capability is ok
  572. if check_capability "$usage" $requiredCapability ; then
  573. lastKeyOK=true
  574. fi
  575. ;;
  576. 'uid') # user ids
  577. if [ "$lastKey" != pub ] ; then
  578. log verbose " ! got a user ID after a sub key?! user IDs should only follow primary keys!"
  579. continue
  580. fi
  581. # if an acceptable user ID was already found, skip
  582. if [ "$uidOK" = 'true' ] ; then
  583. continue
  584. fi
  585. # if the user ID does matches...
  586. if [ "$(echo "$uidfpr" | gpg_unescape)" = "$userID" ] ; then
  587. # and the user ID validity is ok
  588. if [ "$validity" = 'u' -o "$validity" = 'f' ] ; then
  589. # mark user ID acceptable
  590. uidOK=true
  591. else
  592. log debug " - unacceptable user ID validity ($validity)."
  593. fi
  594. else
  595. continue
  596. fi
  597. # output a line for the primary key
  598. # 0 = ok, 1 = bad
  599. if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
  600. log verbose " * acceptable primary key."
  601. if [ -z "$sshKey" ] ; then
  602. log error " ! primary key could not be translated (not RSA?)."
  603. else
  604. echo "0:${sshKey}"
  605. fi
  606. else
  607. log debug " - unacceptable primary key."
  608. if [ -z "$sshKey" ] ; then
  609. log debug " ! primary key could not be translated (not RSA?)."
  610. else
  611. echo "1:${sshKey}"
  612. fi
  613. fi
  614. ;;
  615. 'sub') # sub keys
  616. # unset acceptability of last key
  617. lastKey=sub
  618. lastKeyOK=
  619. fingerprint=
  620. # don't bother with sub keys if the primary key is not valid
  621. if [ "$keyOK" != true ] ; then
  622. continue
  623. fi
  624. # don't bother with sub keys if no user ID is acceptable:
  625. if [ "$uidOK" != true ] ; then
  626. continue
  627. fi
  628. # if sub key validity is not ok, skip
  629. if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
  630. log debug " - unacceptable sub key validity ($validity)."
  631. continue
  632. fi
  633. # if sub key capability is not ok, skip
  634. if ! check_capability "$usage" $requiredCapability ; then
  635. log debug " - unacceptable sub key capability ($usage)."
  636. continue
  637. fi
  638. # mark sub key as ok
  639. lastKeyOK=true
  640. ;;
  641. 'fpr') # key fingerprint
  642. fingerprint="$uidfpr"
  643. sshKey=$(gpg2ssh "$fingerprint")
  644. # if the last key was the pub key, skip
  645. if [ "$lastKey" = pub ] ; then
  646. continue
  647. fi
  648. # output a line for the sub key
  649. # 0 = ok, 1 = bad
  650. if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
  651. log verbose " * acceptable sub key."
  652. if [ -z "$sshKey" ] ; then
  653. log error " ! sub key could not be translated (not RSA?)."
  654. else
  655. echo "0:${sshKey}"
  656. fi
  657. else
  658. log debug " - unacceptable sub key."
  659. if [ -z "$sshKey" ] ; then
  660. log debug " ! sub key could not be translated (not RSA?)."
  661. else
  662. echo "1:${sshKey}"
  663. fi
  664. fi
  665. ;;
  666. esac
  667. done | sort -t: -k1 -n -r
  668. # NOTE: this last sort is important so that the "good" keys (key
  669. # flag '0') come last. This is so that they take precedence when
  670. # being processed in the key files over "bad" keys (key flag '1')
  671. }
  672. # process a single host in the known_host file
  673. process_host_known_hosts() {
  674. local host
  675. local userID
  676. local noKey=
  677. local nKeys
  678. local nKeysOK
  679. local ok
  680. local sshKey
  681. local tmpfile
  682. # set the key processing mode
  683. export MODE='known_hosts'
  684. host="$1"
  685. userID="ssh://${host}"
  686. log verbose "processing: $host"
  687. nKeys=0
  688. nKeysOK=0
  689. IFS=$'\n'
  690. for line in $(process_user_id "${userID}") ; do
  691. # note that key was found
  692. nKeys=$((nKeys+1))
  693. ok=$(echo "$line" | cut -d: -f1)
  694. sshKey=$(echo "$line" | cut -d: -f2)
  695. if [ -z "$sshKey" ] ; then
  696. continue
  697. fi
  698. # remove any old host key line, and note if removed nothing is
  699. # removed
  700. remove_line "$KNOWN_HOSTS" "$sshKey" || noKey=true
  701. # if key OK, add new host line
  702. if [ "$ok" -eq '0' ] ; then
  703. # note that key was found ok
  704. nKeysOK=$((nKeysOK+1))
  705. # hash if specified
  706. if [ "$HASH_KNOWN_HOSTS" = 'true' ] ; then
  707. # FIXME: this is really hackish cause ssh-keygen won't
  708. # hash from stdin to stdout
  709. tmpfile=$(mktemp ${TMPDIR:-/tmp}/tmp.XXXXXXXXXX)
  710. ssh2known_hosts "$host" "$sshKey" > "$tmpfile"
  711. ssh-keygen -H -f "$tmpfile" 2>/dev/null
  712. cat "$tmpfile" >> "$KNOWN_HOSTS"
  713. rm -f "$tmpfile" "${tmpfile}.old"
  714. else
  715. ssh2known_hosts "$host" "$sshKey" >> "$KNOWN_HOSTS"
  716. fi
  717. # log if this is a new key to the known_hosts file
  718. if [ "$noKey" ] ; then
  719. log info "* new key for $host added to known_hosts file."
  720. fi
  721. fi
  722. done
  723. # if at least one key was found...
  724. if [ "$nKeys" -gt 0 ] ; then
  725. # if ok keys were found, return 0
  726. if [ "$nKeysOK" -gt 0 ] ; then
  727. return 0
  728. # else return 2
  729. else
  730. return 2
  731. fi
  732. # if no keys were found, return 1
  733. else
  734. return 1
  735. fi
  736. }
  737. # update the known_hosts file for a set of hosts listed on command
  738. # line
  739. update_known_hosts() {
  740. local returnCode=0
  741. local nHosts
  742. local nHostsOK
  743. local nHostsBAD
  744. local fileCheck
  745. local host
  746. # the number of hosts specified on command line
  747. nHosts="$#"
  748. nHostsOK=0
  749. nHostsBAD=0
  750. # touch the known_hosts file so that the file permission check
  751. # below won't fail upon not finding the file
  752. (umask 0022 && touch "$KNOWN_HOSTS")
  753. # check permissions on the known_hosts file path
  754. check_key_file_permissions $(whoami) "$KNOWN_HOSTS" || failure
  755. # create a lockfile on known_hosts:
  756. lock create "$KNOWN_HOSTS"
  757. # FIXME: we're discarding any pre-existing EXIT trap; is this bad?
  758. trap "lock remove $KNOWN_HOSTS" EXIT
  759. # note pre update file checksum
  760. fileCheck="$(file_hash "$KNOWN_HOSTS")"
  761. for host ; do
  762. # process the host
  763. process_host_known_hosts "$host" || returnCode="$?"
  764. # note the result
  765. case "$returnCode" in
  766. 0)
  767. nHostsOK=$((nHostsOK+1))
  768. ;;
  769. 2)
  770. nHostsBAD=$((nHostsBAD+1))
  771. ;;
  772. esac
  773. # touch the lockfile, for good measure.
  774. lock touch "$KNOWN_HOSTS"
  775. done
  776. # remove the lockfile and the trap
  777. lock remove "$KNOWN_HOSTS"
  778. trap - EXIT
  779. # note if the known_hosts file was updated
  780. if [ "$(file_hash "$KNOWN_HOSTS")" != "$fileCheck" ] ; then
  781. log debug "known_hosts file updated."
  782. fi
  783. # if an acceptable host was found, return 0
  784. if [ "$nHostsOK" -gt 0 ] ; then
  785. return 0
  786. # else if no ok hosts were found...
  787. else
  788. # if no bad host were found then no hosts were found at all,
  789. # and return 1
  790. if [ "$nHostsBAD" -eq 0 ] ; then
  791. return 1
  792. # else if at least one bad host was found, return 2
  793. else
  794. return 2
  795. fi
  796. fi
  797. }
  798. # process hosts from a known_hosts file
  799. process_known_hosts() {
  800. local hosts
  801. # exit if the known_hosts file does not exist
  802. if [ ! -e "$KNOWN_HOSTS" ] ; then
  803. failure "known_hosts file '$KNOWN_HOSTS' does not exist."
  804. fi
  805. log debug "processing known_hosts file:"
  806. log debug " $KNOWN_HOSTS"
  807. hosts=$(meat "$KNOWN_HOSTS" | cut -d ' ' -f 1 | grep -v '^|.*$' | tr , ' ' | tr '\n' ' ')
  808. if [ -z "$hosts" ] ; then
  809. log debug "no hosts to process."
  810. return
  811. fi
  812. # take all the hosts from the known_hosts file (first
  813. # field), grep out all the hashed hosts (lines starting
  814. # with '|')...
  815. update_known_hosts $hosts
  816. }
  817. # process uids for the authorized_keys file
  818. process_uid_authorized_keys() {
  819. local userID
  820. local nKeys
  821. local nKeysOK
  822. local ok
  823. local sshKey
  824. # set the key processing mode
  825. export MODE='authorized_keys'
  826. userID="$1"
  827. log verbose "processing: $userID"
  828. nKeys=0
  829. nKeysOK=0
  830. IFS=$'\n'
  831. for line in $(process_user_id "$userID") ; do
  832. # note that key was found
  833. nKeys=$((nKeys+1))
  834. ok=$(echo "$line" | cut -d: -f1)
  835. sshKey=$(echo "$line" | cut -d: -f2)
  836. if [ -z "$sshKey" ] ; then
  837. continue
  838. fi
  839. # remove the old host key line
  840. remove_line "$AUTHORIZED_KEYS" "$sshKey"
  841. # if key OK, add new host line
  842. if [ "$ok" -eq '0' ] ; then
  843. # note that key was found ok
  844. nKeysOK=$((nKeysOK+1))
  845. ssh2authorized_keys "$userID" "$sshKey" >> "$AUTHORIZED_KEYS"
  846. fi
  847. done
  848. # if at least one key was found...
  849. if [ "$nKeys" -gt 0 ] ; then
  850. # if ok keys were found, return 0
  851. if [ "$nKeysOK" -gt 0 ] ; then
  852. return 0
  853. # else return 2
  854. else
  855. return 2
  856. fi
  857. # if no keys were found, return 1
  858. else
  859. return 1
  860. fi
  861. }
  862. # update the authorized_keys files from a list of user IDs on command
  863. # line
  864. update_authorized_keys() {
  865. local returnCode=0
  866. local userID
  867. local nIDs
  868. local nIDsOK
  869. local nIDsBAD
  870. local fileCheck
  871. # the number of ids specified on command line
  872. nIDs="$#"
  873. nIDsOK=0
  874. nIDsBAD=0
  875. log debug "updating authorized_keys file:"
  876. log debug " $AUTHORIZED_KEYS"
  877. # check permissions on the authorized_keys file path
  878. check_key_file_permissions $(whoami) "$AUTHORIZED_KEYS" || failure
  879. # create a lockfile on authorized_keys
  880. lock create "$AUTHORIZED_KEYS"
  881. # FIXME: we're discarding any pre-existing EXIT trap; is this bad?
  882. trap "lock remove $AUTHORIZED_KEYS" EXIT
  883. # note pre update file checksum
  884. fileCheck="$(file_hash "$AUTHORIZED_KEYS")"
  885. # remove any monkeysphere lines from authorized_keys file
  886. remove_monkeysphere_lines "$AUTHORIZED_KEYS"
  887. for userID ; do
  888. # process the user ID, change return code if key not found for
  889. # user ID
  890. process_uid_authorized_keys "$userID" || returnCode="$?"
  891. # note the result
  892. case "$returnCode" in
  893. 0)
  894. nIDsOK=$((nIDsOK+1))
  895. ;;
  896. 2)
  897. nIDsBAD=$((nIDsBAD+1))
  898. ;;
  899. esac
  900. # touch the lockfile, for good measure.
  901. lock touch "$AUTHORIZED_KEYS"
  902. done
  903. # remove the lockfile and the trap
  904. lock remove "$AUTHORIZED_KEYS"
  905. # remove the trap
  906. trap - EXIT
  907. # note if the authorized_keys file was updated
  908. if [ "$(file_hash "$AUTHORIZED_KEYS")" != "$fileCheck" ] ; then
  909. log debug "authorized_keys file updated."
  910. fi
  911. # if an acceptable id was found, return 0
  912. if [ "$nIDsOK" -gt 0 ] ; then
  913. return 0
  914. # else if no ok ids were found...
  915. else
  916. # if no bad ids were found then no ids were found at all, and
  917. # return 1
  918. if [ "$nIDsBAD" -eq 0 ] ; then
  919. return 1
  920. # else if at least one bad id was found, return 2
  921. else
  922. return 2
  923. fi
  924. fi
  925. }
  926. # process an authorized_user_ids file for authorized_keys
  927. process_authorized_user_ids() {
  928. local line
  929. local nline
  930. local userIDs
  931. authorizedUserIDs="$1"
  932. # exit if the authorized_user_ids file is empty
  933. if [ ! -e "$authorizedUserIDs" ] ; then
  934. failure "authorized_user_ids file '$authorizedUserIDs' does not exist."
  935. fi
  936. log debug "processing authorized_user_ids file:"
  937. log debug " $authorizedUserIDs"
  938. # check permissions on the authorized_user_ids file path
  939. check_key_file_permissions $(whoami) "$authorizedUserIDs" || failure
  940. if ! meat "$authorizedUserIDs" >/dev/null ; then
  941. log debug " no user IDs to process."
  942. return
  943. fi
  944. nline=0
  945. # extract user IDs from authorized_user_ids file
  946. IFS=$'\n'
  947. for line in $(meat "$authorizedUserIDs") ; do
  948. userIDs["$nline"]="$line"
  949. nline=$((nline+1))
  950. done
  951. update_authorized_keys "${userIDs[@]}"
  952. }
  953. # takes a gpg key or keys on stdin, and outputs a list of
  954. # fingerprints, one per line:
  955. list_primary_fingerprints() {
  956. local fake=$(msmktempdir)
  957. GNUPGHOME="$fake" gpg --no-tty --quiet --import
  958. GNUPGHOME="$fake" gpg --with-colons --fingerprint --list-keys | \
  959. awk -F: '/^fpr:/{ print $10 }'
  960. rm -rf "$fake"
  961. }
  962. check_cruft_file() {
  963. local loc="$1"
  964. local version="$2"
  965. if [ -e "$loc" ] ; then
  966. printf "! The file '%s' is no longer used by\n monkeysphere (as of version %s), and can be removed.\n\n" "$loc" "$version" | log info
  967. fi
  968. }
  969. check_upgrade_dir() {
  970. local loc="$1"
  971. local version="$2"
  972. if [ -d "$loc" ] ; then
  973. printf "The presence of directory '%s' indicates that you have\nnot yet completed a monkeysphere upgrade.\nYou should probably run the following script:\n %s/transitions/%s\n\n" "$loc" "$SYSSHAREDIR" "$version" | log info
  974. fi
  975. }
  976. ## look for cruft from old versions of the monkeysphere, and notice if
  977. ## upgrades have not been run:
  978. report_cruft() {
  979. check_upgrade_dir "${SYSCONFIGDIR}/gnupg-host" 0.23
  980. check_upgrade_dir "${SYSCONFIGDIR}/gnupg-authentication" 0.23
  981. check_cruft_file "${SYSCONFIGDIR}/gnupg-authentication.conf" 0.23
  982. check_cruft_file "${SYSCONFIGDIR}/gnupg-host.conf" 0.23
  983. local found=
  984. for foo in "${SYSDATADIR}/backup-from-"*"-transition" ; do
  985. if [ -d "$foo" ] ; then
  986. printf "! %s\n" "$foo" | log info
  987. found=true
  988. fi
  989. done
  990. if [ "$found" ] ; then
  991. printf "The directories above are backups left over from a monkeysphere transition.\nThey may contain copies of sensitive data (host keys, certifier lists), but\nthey are no longer needed by monkeysphere.\nYou may remove them at any time.\n\n" | log info
  992. fi
  993. }